'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var dashEvent = {};
var cache = Object.create(null);
var cacheLowerCaseEvent = Object.create(null);

/**
 * Create a cached version of a pure function.
 */
function cached(fn) {
  return function cachedFn(str) {
    var hit = cache[str];
    return hit || (cache[str] = fn(str));
  };
}

/**
 * Hyphenate a camelCase string.
 */
var hyphenateRE = /\B([A-Z])/g;
var hyphenate = cached(function (str) {
  return str.replace(hyphenateRE, '-$1').toLowerCase();
});

dashEvent.install = function (Vue) {
  var _emit = Vue.prototype.$emit;
  Vue.prototype.$emit = function () {
    var arg = Array.prototype.slice.call(arguments);
    var fnName = arg[0];
    var params = arg.splice(1);
    if (!cacheLowerCaseEvent[fnName] && (cache[fnName] || hyphenateRE.test(fnName))) {
      _emit.call.apply(_emit, [this, fnName].concat((0, _toConsumableArray3['default'])(params)));
      _emit.call.apply(_emit, [this, hyphenate(fnName)].concat((0, _toConsumableArray3['default'])(params)));
    } else {
      cacheLowerCaseEvent[fnName] = fnName;
      _emit.call.apply(_emit, [this, fnName].concat((0, _toConsumableArray3['default'])(params)));
    }
  };
};

exports['default'] = dashEvent;
module.exports = exports['default'];